## gcompris-qt 26.0

=== CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2014 Johnny Jazeix <jazeix@gmail.com>
#
# SPDX-License-Identifier: BSD-3-Clause
#=============================================================================
cmake_minimum_required(VERSION 3.16)

project(gcompris-qt C CXX)

# get all the redist dll needed for windows when compiling with vc
set(CMAKE_INSTALL_UCRT_LIBRARIES 1)
include(InstallRequiredSystemLibraries)

# Set c++17 support
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# enable qml debugging for DEBUG builds:
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DQT_QML_DEBUG")

set(GCOMPRIS_MAJOR_VERSION 26)
set(GCOMPRIS_MINOR_VERSION 0)
set(GCOMPRIS_PATCH_VERSION 0)

if("${CMAKE_ANDROID_ARCH}" STREQUAL "arm64")
  set(GCOMPRIS_PATCH_VERSION 1)
endif()

# Set the BUILD_DATE
string(TIMESTAMP BUILD_DATE %Y%m)

include(FeatureSummary)
include(GNUInstallDirs)

# cmake modules setup
find_package(ECM 1.4.0 QUIET NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake/)

# KDE po to qm tools
if(ECM_FOUND)
  include(ECMAddTests)

  option(BUILD_TESTING "Build and enable unit tests" OFF)
  include(ECMCoverageOption)
endif()

add_compile_definitions(QT_DISABLE_DEPRECATED_BEFORE=0x060500)

# add tools (cppcheck, clang-tidy...) if build on testing mode only
# (slower compilation)
if(BUILD_TESTING)
  include(CodeQualityUtils)
endif()

set(QT_REQUIRED_VERSION 6.5.0)

if(CMAKE_SYSTEM_NAME STREQUAL Android)
  set(ANDROID 1)
  # Require ndk minimum version to 25
  if(ANDROID_NDK_REVISION VERSION_LESS "25.0.0")
    message(FATAL_ERROR "android ndk 25 minimal required, actually using ${ANDROID_NDK_REVISION}")
  endif()

  option(USE_16KB_PAGESIZE "For android, option to compile with 16 KB pages size (mandatory since Nov 2025)" OFF)

  # TODO: possibly should be setup by toolchain one day
  set(QT_QMAKE_EXECUTABLE "${_qt5Core_install_prefix}/bin/qmake")
  if(ECM_VERSION VERSION_GREATER "5.55.0")
    set(QT_REQUIRED_VERSION 5.12.0)
  endif()

  # workaround until this fix is in released ECM
  if(ECM_VERSION VERSION_LESS "5.15.0")
    add_definitions(-DANDROID)
  endif()
endif()

# Set executable filename
if(ANDROID OR HAIKU OR WIN32)
  set(GCOMPRIS_EXECUTABLE_NAME GCompris)
else()
  set(GCOMPRIS_EXECUTABLE_NAME gcompris-qt)
endif()

set(GCOMPRIS_VERSION ${GCOMPRIS_MAJOR_VERSION}.${GCOMPRIS_MINOR_VERSION})

# An integer value that represents the version of the application
# Increase it at each release
math(EXPR GCOMPRIS_VERSION_CODE "${GCOMPRIS_MAJOR_VERSION}*10000 + ${GCOMPRIS_MINOR_VERSION}*100 + ${GCOMPRIS_PATCH_VERSION}")

# prevent build in source directory
if("${CMAKE_BINARY_DIR}" STREQUAL "${CMAKE_SOURCE_DIR}")
    message(SEND_ERROR "Building in the source directory is not supported.")
    message(FATAL_ERROR "Please remove the created \"CMakeCache.txt\" file, the \"CMakeFiles\"
            directory and create a build directory and call \"${CMAKE_COMMAND} <path to the sources>\".")
endif()

set(QT_MAJOR Qt6)

set(QT_COMPONENTS Qml Quick Gui Multimedia Core Svg Network LinguistTools Sensors QuickControls2 QuickTemplates2 QmlWorkerScript)

find_package(QT NAMES Qt6)
find_package(${QT_MAJOR} ${QT_REQUIRED_VERSION} COMPONENTS
    ${QT_COMPONENTS})

set_package_properties(${QT_MAJOR} PROPERTIES TYPE REQUIRED)
foreach(COMPONENT ${QT_COMPONENTS})
  set_package_properties(${QT_MAJOR}${COMPONENT} PROPERTIES TYPE REQUIRED)
endforeach()

set(QT_VERSION "${QT_VERSION_MAJOR}.${QT_VERSION_MINOR}.${QT_VERSION_PATCH}")
if(QT_VERSION VERSION_LESS "6.9.0")
  find_package(${QT_MAJOR} ${QT_REQUIRED_VERSION} COMPONENTS Charts Widgets)
  set_package_properties(${QT_MAJOR}Charts PROPERTIES TYPE REQUIRED)
  set_package_properties(${QT_MAJOR}Widgets PROPERTIES TYPE REQUIRED)
else()
  find_package(${QT_MAJOR} ${QT_REQUIRED_VERSION} COMPONENTS Graphs Quick3D)
  set_package_properties(${QT_MAJOR}Graphs PROPERTIES TYPE REQUIRED)
  set_package_properties(${QT_MAJOR}Quick3D PROPERTIES TYPE REQUIRED)
endif()

# It seems to only be present on some Linux distributions, not FreeBSD for example and starting Qt6.6 so not enforcing it
find_package(${QT_MAJOR} ${QT_REQUIRED_VERSION} OPTIONAL_COMPONENTS QuickControls2Basic)

# Needed for android internal paths
if(ANDROID)
  find_package(${QT_MAJOR} ${QT_REQUIRED_VERSION} COMPONENTS CorePrivate)
  set_package_properties(${QT_MAJOR}CorePrivate PROPERTIES TYPE REQUIRED)
endif()

# Set Qt policy, introduced in Qt6.8
if(QT_KNOWN_POLICY_QTP0004)
  qt6_policy(SET QTP0004 NEW)
endif()

# Starting C++20, emit() is a function in standard library. To avoid using Qt keywords like signals, slots, emit, we define this variable
add_definitions(
    -DQT_USE_QSTRINGBUILDER
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_NO_KEYWORDS
    -DQT_NO_FOREACH
)

if(UNIX AND NOT APPLE AND NOT ANDROID)
  find_package(${QT_MAJOR} ${QT_REQUIRED_VERSION} OPTIONAL_COMPONENTS WaylandClient)
endif()

# For systems where ICU is not packaged with Qt installer
# And we want to package it from system
option(SHIP_SYSTEM_ICU "Ship system ICU in packages and not the one packaged by Qt" OFF)
if(SHIP_SYSTEM_ICU)
  find_package(ICU COMPONENTS data uc i18n)
  set_package_properties(ICU PROPERTIES TYPE REQUIRED)
endif()

find_package(OpenSSL)
# OpenSSL will be compiled as external_project for android
if(NOT ANDROID)
  set_package_properties(OpenSSL PROPERTIES TYPE REQUIRED)
endif()

option(COMPILE_DOC "Enable compilation of GCompris docbook" OFF)
if(COMPILE_DOC)
  find_package(KF6 QUIET COMPONENTS DocTools)
endif()

if(ECM_FOUND)
    include(KDEInstallDirs)

    if(ECM_VERSION VERSION_GREATER "1.6.0")
        add_subdirectory(images)
        install(FILES org.kde.gcompris.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})
        install(FILES org.kde.gcompris.desktop DESTINATION ${KDE_INSTALL_APPDIR})
    else()
        message(STATUS "ECM_VERSION is ${ECM_VERSION}, icons and desktop files won't be installed.")
    endif()
endif()

option(PACKAGE_GCOMPRIS "Package GCompris (default)" ON)

option(BUILD_SERVER "Build the server along the application" ON)
option(PACKAGE_SERVER "Package the server" OFF)

if(BUILD_SERVER)
  find_package(${QT_MAJOR} ${QT_REQUIRED_VERSION} COMPONENTS Sql)
  set_package_properties(${QT_MAJOR}Sql PROPERTIES TYPE REQUIRED)

  find_package(${QT_MAJOR} ${QT_REQUIRED_VERSION} COMPONENTS QuickDialogs2)
  set_package_properties(${QT_MAJOR}QuickDialogs2 PROPERTIES TYPE REQUIRED)
endif()

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

# Tell CMake to run moc when necessary:
set(CMAKE_AUTOMOC ON)

# As moc files are generated in the binary dir, tell CMake
# to always look for includes there:
set(CMAKE_INCLUDE_CURRENT_DIR ON)

#get_cmake_property(_variableNames VARIABLES)
#foreach (_variableName ${_variableNames})
#    message("${_variableName}=${${_variableName}}")
#endforeach()

option(WITH_RCC "Use rcc for activities instead of qml plugins" ON)

option(WITH_DOWNLOAD "Internal download" ON)
# @FIXME These permissions should be removed if download is disable
#        but it makes the application crash on exit (tested on Android 6)
set(ANDROID_INTERNET_PERMISSION "<uses-permission android:name=\"android.permission.INTERNET\" />")
set(ANDROID_ACCESS_NETWORK_STATE_PERMISSION "<uses-permission android:name=\"android.permission.ACCESS_NETWORK_STATE\" />")

# Enable wifi broadcase on Android to communicate with the server
set(ANDROID_WIFI_BROADCAST_PERMISSION "<uses-permission android:name=\"android.permission.ACCESS_WIFI_STATE\" />\n
    <uses-permission android:name=\"android.permission.CHANGE_WIFI_MULTICAST_STATE\" />\n
    <uses-permission android:name=\"android.permission.WAKE_LOCK\" />")

set(GRAPHICAL_RENDERER "auto" CACHE STRING "Policy for choosing the renderer backend [opengl|software|auto]")

# Set output directory
if(CMAKE_HOST_APPLE)
  set(_bundle_bin gcompris-qt.app/Contents/MacOS)
  set(_data_dest_dir ${CMAKE_INSTALL_BINDIR}/${_bundle_bin}/../Resources)
else()
  set(_data_dest_dir ${CMAKE_INSTALL_DATADIR}/${GCOMPRIS_EXECUTABLE_NAME})
endif()
if(ANDROID)
  # Android .so output
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/android-build/libs/${ANDROID_ABI}/)
  set(GCOMPRIS_TRANSLATIONS_DIR ${CMAKE_BINARY_DIR}/${_data_dest_dir} CACHE INTERNAL "" FORCE)
  set(GCOMPRIS_RCC_DIR ${CMAKE_BINARY_DIR}/android-build/assets/${_data_dest_dir}/rcc CACHE INTERNAL "" FORCE)
  set(ANDROID_PACKAGE "net.gcompris.full")
  add_subdirectory(android)
elseif(CMAKE_HOST_APPLE)
  # MacOSX build
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
  set(GCOMPRIS_TRANSLATIONS_DIR ${CMAKE_BINARY_DIR}/${_data_dest_dir}/translations CACHE INTERNAL "" FORCE)
  set(GCOMPRIS_RCC_DIR ${CMAKE_BINARY_DIR}/${_data_dest_dir}/rcc CACHE INTERNAL "" FORCE)
else()
  # Desktop build
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
  set(GCOMPRIS_TRANSLATIONS_DIR ${CMAKE_BINARY_DIR}/${_data_dest_dir}/translations CACHE INTERNAL "" FORCE)
  set(GCOMPRIS_RCC_DIR ${CMAKE_BINARY_DIR}/${_data_dest_dir}/rcc CACHE INTERNAL "" FORCE)
endif()

# Always create these folders
add_custom_command(
  OUTPUT shareFolders
  COMMAND cmake -E make_directory ${GCOMPRIS_TRANSLATIONS_DIR}
  COMMAND cmake -E make_directory ${GCOMPRIS_RCC_DIR}
  )
add_custom_target(
  createShareFolders ALL
  DEPENDS shareFolders
  )

include(cmake/rcc.cmake)

# Translations handling
#skipping translations can be useful during dev builds
option(SKIP_TRANSLATIONS "Skip building translation files" OFF)
if(NOT SKIP_TRANSLATIONS)
  include(cmake/translation.cmake)
  gcompris_create_translation_files(FILENAME gcompris_qt)
  if(BUILD_SERVER)
    gcompris_create_translation_files(FILENAME gcompris_teachers_qt)
  endif()
endif()

if(CMAKE_HOST_APPLE)
  install(DIRECTORY ${GCOMPRIS_TRANSLATIONS_DIR} DESTINATION ${_bundle_bin})
elseif(ANDROID)
  install(DIRECTORY ${GCOMPRIS_TRANSLATIONS_DIR} DESTINATION ${CMAKE_INSTALL_DATADIR})
else()
  install(DIRECTORY ${GCOMPRIS_TRANSLATIONS_DIR} DESTINATION ${_data_dest_dir})
endif()

# Build standalone package option -> if ON, we will copy the required Qt files in the build package.
# If OFF, "make install" will not copy Qt files so only GCompris files will be packaged.
# By default, it is true on Windows (as we deliver NSIS package), macOS (bundled), android (apk) and false on linux (to do make install)
# If you want to create a STGZ package for linux (auto-extractible), override this variable by typing : cmake -DBUILD_STANDALONE=ON
if(UNIX AND NOT ANDROID AND NOT APPLE)
  option(BUILD_STANDALONE "Build a standalone package when typing 'make package'" OFF)
else()
  option(BUILD_STANDALONE "Build a standalone package when typing 'make package'" ON)
endif()

# Default to Release if we build a package
if(BUILD_STANDALONE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build." FORCE)
endif()

option(WITH_KIOSK_MODE "Set the kiosk mode by default" OFF)

if(WIN32)
  set(COMPRESSED_AUDIO "mp3" CACHE STRING "Compressed Audio format [ogg|aac|mp3]")
elseif(APPLE)
  set(COMPRESSED_AUDIO "aac" CACHE STRING "Compressed Audio format [ogg|aac|mp3]")
else()
  set(COMPRESSED_AUDIO "ogg" CACHE STRING "Compressed Audio format [ogg|aac|mp3]")
endif()

file(GLOB_RECURSE OGG_FILES ${CMAKE_CURRENT_SOURCE_DIR}/src/ "*.ogg")

foreach(OGG_FILE ${OGG_FILES})
  # This should only replace the extension
  string(REGEX REPLACE "ogg$" "aac" AAC_FILE ${OGG_FILE})
  add_custom_command(
    OUTPUT ${AAC_FILE}
    # Put the good line depending on your installation
    COMMAND avconv -v warning -i ${OGG_FILE} -acodec libvo_aacenc ${AAC_FILE}
    #COMMAND ffmpeg -v warning -i ${OGG_FILE} -acodec aac -strict -2 ${AAC_FILE}
    )
  list(APPEND AAC_FILES ${AAC_FILE})

  # This should only replace the extension
  string(REGEX REPLACE "ogg$" "mp3" MP3_FILE ${OGG_FILE})
  add_custom_command(
    OUTPUT ${MP3_FILE}

=== android/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2014 Johnny Jazeix <jazeix@gmail.com>
#
# SPDX-License-Identifier: BSD-3-Clause
#=============================================================================
#android build
# copied/inspired from stellarium project (http://www.stellarium.org/wiki/index.php/Building_for_Android)

list(APPEND JAVA_SRCS "src/net/gcompris/GComprisActivity.java")

foreach(JavaSource ${JAVA_SRCS})
  add_custom_command(
    OUTPUT ${CMAKE_BINARY_DIR}/android-build/${JavaSource}
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/${JavaSource} ${CMAKE_BINARY_DIR}/android-build/${JavaSource}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${JavaSource}
    )
  list(APPEND TARGET_JAVA_FILES ${CMAKE_BINARY_DIR}/android-build/${JavaSource})
endforeach()

add_custom_target(java_src DEPENDS ${TARGET_JAVA_FILES})

find_program(ANDROID_DEPLOY_QT NAMES androiddeployqt PATHS ${QT_HOST_PATH}/${QT6_HOST_INFO_BINDIR})

# Look for androiddeployqt program
if(NOT ANDROID_DEPLOY_QT)
  message(FATAL_ERROR "Could not find androiddeployqt. Make sure you set all the Qt6_* paths to the Qt for android compiled version.")
endif()

# Set version
set(ANDROID_VERSION_NAME ${GCOMPRIS_VERSION})

# Set a name representing the build type
set(APK_SUFFIX "-")

# _HOST have been removed from ECM in https://cgit.kde.org/extra-cmake-modules.git/commit/?id=731ba7036effcc430f98031e7f2a9826f6234cba
set(_HOST "${CMAKE_HOST_SYSTEM_NAME}-${CMAKE_HOST_SYSTEM_PROCESSOR}")
string(TOLOWER "${_HOST}" _HOST)

if(WITH_DOWNLOAD)
  set(APK_SUFFIX "-dl${APK_SUFFIX}")
endif()

if(WITH_KIOSK_MODE)
  set(APK_SUFFIX "-kiosk${APK_SUFFIX}")
endif()

set(STDCPP_PATH "\"stdcpp-path\": \"${ANDROID_NDK}/toolchains/llvm/prebuilt/linux-x86_64/sysroot/usr/lib/\"")

set(ANDROID_TOOLCHAIN arm-linux-androideabi)
if("${CMAKE_ANDROID_ARCH}" STREQUAL "arm64")
  set(ANDROID_TOOLCHAIN aarch64-linux-android)
endif()

# set android package source for androiddeployqt json file
set(PACKAGE_SOURCE_ANDROID ${CMAKE_BINARY_DIR}/tmpAndroid)
set(ANDROID_SDK_ROOT $ENV{ANDROID_SDK_ROOT})

# Copied from ECM
file(GLOB build-tools LIST_DIRECTORIES TRUE RELATIVE ${ANDROID_SDK_ROOT}/build-tools ${ANDROID_SDK_ROOT}/build-tools/*)
list(SORT build-tools COMPARE NATURAL)
list(GET build-tools -1 _default_sdk)
set(ANDROID_SDK_BUILD_TOOLS_REVISION "${_default_sdk}" CACHE STRING "Android Build Tools version")

# Copied from ~/Qt/6.4.2/android_armv7/lib/cmake/Qt6Core/Qt6AndroidMacros.cmake
set(QT_ANDROID_ARCHITECTURES "")
set(architecture_record_list "")
foreach(abi IN LISTS qt_android_abis CMAKE_ANDROID_ARCH_ABI)
  if(abi STREQUAL "x86")
    set(arch_value "i686-linux-android")
  elseif(abi STREQUAL "x86_64")
    set(arch_value "x86_64-linux-android")
  elseif(abi STREQUAL "arm64-v8a")
    set(arch_value "aarch64-linux-android")
  elseif(abi)
    set(arch_value "arm-linux-androideabi")
  endif()
  list(APPEND architecture_record_list "\"${abi}\":\"${arch_value}\"")
endforeach()

list(JOIN architecture_record_list "," QT_ANDROID_ARCHITECTURES)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/AndroidManifest.xml.cmake ${PACKAGE_SOURCE_ANDROID}/AndroidManifest.xml @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/configAndroid.json.cmake ${PACKAGE_SOURCE_ANDROID}/configAndroid.json @ONLY)
# TODO Remove this file as soon as we have moved to plugins instead of rcc files for activities
# This way, we'll use the one provided by Qt
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/build.gradle ${PACKAGE_SOURCE_ANDROID}/build.gradle @ONLY)

# Get all po files in po/ to create the values-{locale} in order to have the locales available in android
file(GLOB TRANSLATIONS_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "../po/*.po")
foreach(PoSource ${TRANSLATIONS_FILES})
  # Remove suffix ".po"
  string(REPLACE ".po" "" PoSource ${PoSource})
  # Remove prefix "../po/gcompris_"
  string(REPLACE "../po/gcompris_" "" locale ${PoSource})
  # replace _ par -r for locales with country
  string(REPLACE "_" "-r" locale ${locale})

  add_custom_command(
    OUTPUT ${locale}
    COMMAND cmake -E make_directory ${GCOMPRIS_TRANSLATIONS_DIR}
    COMMAND cmake -E make_directory ${CMAKE_BINARY_DIR}/android-build/res/values-${locale}
    COMMAND cmake -E copy ${CMAKE_SOURCE_DIR}/android/strings.xml ${CMAKE_BINARY_DIR}/android-build/res/values-${locale}/strings.xml
    )
  list(APPEND ALL_LOCALES ${locale})
endforeach()

add_custom_command(
  OUTPUT createApkFromAndroidDeployQtDebug
  DEPENDS ${PACKAGE_SOURCE_ANDROID}/AndroidManifest.xml
  COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR} ${PACKAGE_SOURCE_ANDROID}
  COMMAND ${ANDROID_DEPLOY_QT} --output ${CMAKE_BINARY_DIR}/android-build/ --input ${PACKAGE_SOURCE_ANDROID}/configAndroid.json --debug --apk ${CMAKE_BINARY_DIR}/android-build/GCompris-Android-debug-${ANDROID_ABI}${APK_SUFFIX}${GCOMPRIS_VERSION}.apk
)

add_custom_command(
  OUTPUT createApkFromAndroidDeployQtRelease
  DEPENDS ${PACKAGE_SOURCE_ANDROID}/AndroidManifest.xml
  COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR} ${PACKAGE_SOURCE_ANDROID}
  COMMAND ${ANDROID_DEPLOY_QT} --output ${CMAKE_BINARY_DIR}/android-build/ --input ${PACKAGE_SOURCE_ANDROID}/configAndroid.json --release --apk ${CMAKE_BINARY_DIR}/android-build/GCompris-Android-release-${ANDROID_ABI}${APK_SUFFIX}${GCOMPRIS_VERSION}.apk
)

add_custom_command(
  OUTPUT createApkSignedAlignedFromAndroidDeployQtRelease
  DEPENDS ${PACKAGE_SOURCE_ANDROID}/AndroidManifest.xml
  COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR} ${PACKAGE_SOURCE_ANDROID}
  COMMAND ${ANDROID_DEPLOY_QT} --output ${CMAKE_BINARY_DIR}/android-build/ --input ${PACKAGE_SOURCE_ANDROID}/configAndroid.json --release --sign $ENV{ANDROID_KEYSTORE} gcompris --storepass $ENV{ANDROID_KEYSTORE_PASSWD} --verbose --apk ${CMAKE_BINARY_DIR}/android-build/GCompris-Android-release-signed-aligned-${ANDROID_ABI}${APK_SUFFIX}${GCOMPRIS_VERSION}.apk
)

add_custom_command(
  OUTPUT createAabFromAndroidDeploy
  DEPENDS ${PACKAGE_SOURCE_ANDROID}/AndroidManifest.xml
  COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR} ${PACKAGE_SOURCE_ANDROID}
  COMMAND ${ANDROID_DEPLOY_QT} --output ${CMAKE_BINARY_DIR}/android-build/ --input ${PACKAGE_SOURCE_ANDROID}/configAndroid.json --aab --release
  COMMAND ${CMAKE_COMMAND} -E rename ${CMAKE_BINARY_DIR}/android-build/build/outputs/bundle/release/android-build-release.aab ${CMAKE_BINARY_DIR}/android-build/GCompris-Android-release${APK_SUFFIX}${GCOMPRIS_VERSION}.aab
  )

add_custom_command(
  OUTPUT apkInstall
  DEPENDS ${CMAKE_BINARY_DIR}/android-build/GCompris-Android-release-signed-aligned-${ANDROID_ABI}${APK_SUFFIX}${GCOMPRIS_VERSION}.apk
  COMMAND ${ANDROID_SDK_ROOT}/platform-tools/adb install -r ${CMAKE_BINARY_DIR}/android-build/GCompris-Android-release-signed-aligned-${ANDROID_ABI}${APK_SUFFIX}${GCOMPRIS_VERSION}.apk
)

# Command to create apk from Makefile
add_custom_target(apk_debug
  DEPENDS ${ALL_LOCALES} move_translations_to_assets createApkFromAndroidDeployQtDebug java_src
)

# Command to create apk from Makefile
add_custom_target(apk_release
  DEPENDS ${ALL_LOCALES} move_translations_to_assets createApkFromAndroidDeployQtRelease java_src
)

# Command to create aligned signed apk from Makefile
add_custom_target(apk_aligned_signed
  DEPENDS ${ALL_LOCALES} move_translations_to_assets createApkSignedAlignedFromAndroidDeployQtRelease java_src
)

# Command to create aab from Makefile
add_custom_target(aab_release
  DEPENDS ${ALL_LOCALES} move_translations_to_assets createAabFromAndroidDeploy java_src
)

# Command to install the signed aligned apk through adb from Makefile
add_custom_target(apk_install
  DEPENDS apkInstall
)

# compile openssl needed to download from https
include(ExternalProject)
set(OPENSSL_DIR "${CMAKE_BINARY_DIR}/external/openssl/")

set(suffix_libssl ".so")

find_program(LLVM_STRIP NAMES llvm-strip PATHS ${ANDROID_NDK}/toolchains/llvm/prebuilt/linux-x86_64/bin/)

ExternalProject_Add(
  ext_openssl
  DOWNLOAD_DIR ${CMAKE_BINARY_DIR}
  SOURCE_DIR ${OPENSSL_DIR}
  URL https://github.com/openssl/openssl/releases/download/openssl-3.6.0/openssl-3.6.0.tar.gz
  URL_HASH SHA256=b6a5f44b7eb69e3fa35dbf15524405b44837a481d43d81daddde3ff21fcbb8e9
  BUILD_IN_SOURCE 1
  CONFIGURE_COMMAND
  ${CMAKE_COMMAND} -E env PATH=${ANDROID_NDK}/toolchains/llvm/prebuilt/linux-x86_64/bin:$ENV{PATH}
  ./Configure --prefix=${CMAKE_BINARY_DIR}/android-build --openssldir=./ssl android-${CMAKE_ANDROID_ARCH} shared
  BUILD_COMMAND
  ${CMAKE_COMMAND} -E env PATH=${ANDROID_NDK}/toolchains/llvm/prebuilt/linux-x86_64/bin:$ENV{PATH}
  make SHLIB_VERSION_NUMBER= SHLIB_EXT= build_libs &&
  ${LLVM_STRIP} --strip-all libcrypto.so &&
  ${LLVM_STRIP} --strip-all libssl.so &&
  cp libcrypto.so libcrypto_3.so &&
  cp libssl.so libssl_3.so
  INSTALL_COMMAND
  ${CMAKE_COMMAND} -E make_directory "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}" &&
  ${CMAKE_COMMAND} -E copy "${OPENSSL_DIR}/libcrypto_3.so" "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/" &&
  ${CMAKE_COMMAND} -E copy "${OPENSSL_DIR}/libssl_3.so" "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/"
  )

#
add_custom_command(
  OUTPUT move_translations_to_assets
  COMMAND ${CMAKE_COMMAND} -E copy_directory ${GCOMPRIS_TRANSLATIONS_DIR} ${CMAKE_BINARY_DIR}/android-build/assets/share/GCompris
  )

if(TARGET create-apk)
  set(PACKAGE_DIR ${PACKAGE_SOURCE_ANDROID})
  set_target_properties(create-apk-GCompris PROPERTIES ANDROID_APK_DIR "${PACKAGE_DIR}")
  add_custom_target(gcompris-move-metadata ALL
    COMMAND cmake -E echo "Moving GCompris shared Android resources"
    COMMAND cmake -E make_directory ${PACKAGE_SOURCE_ANDROID}
    COMMAND cmake -E copy_directory "${CMAKE_CURRENT_SOURCE_DIR}" "${PACKAGE_SOURCE_ANDROID}"
    )
  add_dependencies(create-apk gcompris-move-metadata)
endif()

=== src/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2014 Johnny Jazeix <jazeix@gmail.com>
#
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
add_subdirectory(core)
add_subdirectory(activities)

if(BUILD_SERVER AND NOT ANDROID)
  add_subdirectory(server)
endif()

=== docs/docbook/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2015 Burkhard Lück <lueck@hube-lueck.de>
#
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
########### install files ###############
#
#
kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en SUBDIR gcompris)

=== src/activities/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2014 Johnny Jazeix <jazeix@gmail.com>
#
# SPDX-License-Identifier: BSD-3-Clause
#=============================================================================
add_subdirectory(menu)

# Read the activities.txt file
file(READ activities.txt ACTIVITIES)
# Split the output on a list containing each line
string(REGEX REPLACE ";" "\\\\;" ACTIVITIES "${ACTIVITIES}")
string(REGEX REPLACE "\n" ";" ACTIVITIES "${ACTIVITIES}")
file(REMOVE "activities_out.txt")

add_custom_target(all_activities)

foreach(ACTIVITY ${ACTIVITIES})
  # For each line found, we remove comments
  string(FIND "${ACTIVITY}" "#" match)
  if(${match})
    # Set activities as options (enabled by default)
    option("USE_${ACTIVITY}" "Enable ${ACTIVITY} activity" ON)
    if(USE_${ACTIVITY})
      # Add the directory for compilation
      add_subdirectory(${ACTIVITY})
      file(APPEND "activities_out.txt" "${ACTIVITY}\n")
      if(TARGET rcc_${ACTIVITY})
        add_dependencies(all_activities "rcc_${ACTIVITY}")
      endif()
    endif()
  endif(${match})
endforeach(ACTIVITY ${ACTIVITIES})

GCOMPRIS_ADD_RCC(activities RESOURCES activities_out.txt)
GCOMPRIS_ADD_RCC(activities_light
  QML_FILES
  */ActivityInfo.qml
  RESOURCES
  activities_out.txt
  *.svg)

=== src/core/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2014 Johnny Jazeix <jazeix@gmail.com>
#
# SPDX-License-Identifier: BSD-3-Clause
#=============================================================================
include(qt_helper)

configure_file(config.h.in "${CMAKE_CURRENT_BINARY_DIR}/config.h" @ONLY)

if(WITH_KIOSK_MODE)
  add_definitions(-DWITH_KIOSK_MODE)
endif()

if (UBUNTU_TOUCH)
  add_definitions(-DUBUNTUTOUCH)
endif()

set(gcompris_SRCS
  ActivityInfo.cpp
  ActivityInfo.h
  ActivityInfoTree.cpp
  ActivityInfoTree.h
  ApplicationInfo.cpp
  ApplicationInfo.h
  ApplicationSettings.cpp
  ApplicationSettings.h
  File.cpp
  File.h
  Dataset.cpp
  Dataset.h
  Directory.cpp
  Directory.h
  DownloadManager.cpp
  DownloadManager.h
  GImageGrabber.cpp
  GImageGrabber.h
  config.h.in
  ClientNetworkMessages.cpp
  ClientNetworkMessages.h
  netconst.h
  synth/ADSRenvelope.cpp
  synth/ADSRenvelope.h
  GSynth.cpp
  GSynth.h
  synth/linearSynthesis.cpp
  synth/linearSynthesis.h
  synth/modulation.cpp
  synth/modulation.h
  synth/generator.cpp
  synth/generator.h
  synth/preset.h
  synth/preset.cpp
  synth/waveform.cpp
  synth/waveform.h
)
if(WITH_RCC)
  list(APPEND gcompris_SRCS GComprisPlugin.cpp GComprisPlugin.h)
endif()

if(ANDROID)
  list(APPEND gcompris_SRCS ApplicationAndroid.cpp)
else()
  list(APPEND gcompris_SRCS ApplicationInfoDefault.cpp)
endif()

# Resources
set(GCOMPRIS_RESOURCES "${PROJECT_SOURCE_DIR}/installer")
if(CMAKE_HOST_WIN32)
  set(gcompris_icon GCompris.ico)
  set(gcompris_RES
    ${GCOMPRIS_RESOURCES}/${gcompris_icon}
    GCompris.rc
  )
elseif(CMAKE_HOST_APPLE)
  set(gcompris_icon GCompris.icns)
  set(gcompris_RES ${GCOMPRIS_RESOURCES}/${gcompris_icon})
  set_source_files_properties(${gcompris_RES} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
endif()

set(used_qt_modules ${QT_MAJOR}::Qml ${QT_MAJOR}::Quick ${QT_MAJOR}::Gui ${QT_MAJOR}::Multimedia ${QT_MAJOR}::Core ${QT_MAJOR}::Svg ${QT_MAJOR}::Sensors ${QT_MAJOR}::QuickControls2 ${QT_MAJOR}::QuickTemplates2 ${QT_MAJOR}::QmlWorkerScript)

if(TARGET ${QT_MAJOR}::CorePrivate)
  set(used_qt_modules ${used_qt_modules} ${QT_MAJOR}::CorePrivate)
endif()

if(QT_VERSION VERSION_LESS "6.9.0")
  set(used_qt_modules ${used_qt_modules} ${QT_MAJOR}::Widgets ${QT_MAJOR}::Charts)
else()
  set(used_qt_modules ${used_qt_modules} ${QT_MAJOR}::Graphs ${QT_MAJOR}::Quick3D)
endif()

if(TARGET ${QT_MAJOR}::QuickControls2Basic)
  set(used_qt_modules ${used_qt_modules} ${QT_MAJOR}::QuickControls2Basic)
  if(TARGET ${QT_MAJOR}::QuickControls2BasicPrivate)
    set(used_qt_modules ${used_qt_modules} ${QT_MAJOR}::QuickControls2BasicPrivate)
  endif()

  # This should not be needed! But for some reason, on windows it does not find
  # automatically the library so we need to install it manually
  if(WIN32)
    get_target_property(QuickControls2BasicLibrary ${QT_MAJOR}::QuickControls2Basic IMPORTED_LOCATION)
    install(FILES ${QuickControls2BasicLibrary} DESTINATION ${CMAKE_INSTALL_BINDIR})
  endif()
endif()

if(TARGET ${QT_MAJOR}::WaylandClient)
  set(used_qt_modules ${used_qt_modules} ${QT_MAJOR}::WaylandClient)
  if(TARGET ${QT_MAJOR}::WaylandClientPrivate)
    set(used_qt_modules ${used_qt_modules} ${QT_MAJOR}::WaylandClientPrivate)
  endif()
endif()

if(ANDROID)
  add_library(${GCOMPRIS_EXECUTABLE_NAME} SHARED main.cpp)
elseif(CMAKE_HOST_APPLE)
  add_executable(${GCOMPRIS_EXECUTABLE_NAME} MACOSX_BUNDLE ${gcompris_RES} main.cpp)
elseif(CMAKE_HOST_WIN32)
  add_executable(${GCOMPRIS_EXECUTABLE_NAME} WIN32 ${gcompris_RES} main.cpp)
else()
  add_executable(${GCOMPRIS_EXECUTABLE_NAME} ${gcompris_RES} main.cpp)
endif()

add_library(gcompris_core STATIC ${gcompris_SRCS})
target_link_libraries(gcompris_core ${used_qt_modules})

target_link_libraries(${GCOMPRIS_EXECUTABLE_NAME} gcompris_core ${used_qt_modules})

if (USE_16KB_PAGESIZE)
  target_link_options(${GCOMPRIS_EXECUTABLE_NAME} PRIVATE "-Wl,-z,max-page-size=16384")
endif()

if(WITH_RCC)
  GCOMPRIS_ADD_RCC(core
    QML_FILES
    *.qml
    *.js
    RESOURCES
    resource/*.${COMPRESSED_AUDIO}
    resource/*.gif
    resource/*.png
    resource/*.svg
    resource/*.pem
    resource/bonus/*
    resource/sounds/*
    resource/fonts/*.*
    qmldir
    COPYING
  )
else()
  add_library(core SHARED)
  file(GLOB core_qml_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.qml *.js)
  file(GLOB core_resources_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} resource/*.${COMPRESSED_AUDIO} resource/*.gif resource/*.png resource/*.svg resource/*.pem resource/bonus/* resource/sounds/* resource/fonts/*.*)

  set_source_files_properties(GCSingletonFontLoader.qml GCStyle.qml PROPERTIES
    QT_QML_SINGLETON_TYPE TRUE
    )
  qt_add_qml_module(
    core
    URI core
    RESOURCE_PREFIX /gcompris/src/
    VERSION 1.0
    QML_FILES
    ${core_qml_files}
    RESOURCES
    ${core_resources_files}
    )
  target_link_libraries(${GCOMPRIS_EXECUTABLE_NAME} core)
endif()

if(ANDROID)
  set_property(TARGET ${GCOMPRIS_EXECUTABLE_NAME} PROPERTY SUFFIX "_${CMAKE_ANDROID_ARCH_ABI}.so")
endif()
# Installation
# ============

if(PACKAGE_GCOMPRIS)
  include(PackageGCompris.cmake)
endif()

=== src/server/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2021 Johnny Jazeix <jazeix@gmail.com>
#
# SPDX-License-Identifier: BSD-3-Clause
#=============================================================================
include(qt_helper)

if(HAIKU OR WIN32)
  set(GCOMPRIS_TEACHERS_EXECUTABLE_NAME GCompris-Teachers)
else()
  set(GCOMPRIS_TEACHERS_EXECUTABLE_NAME gcompris-teachers)
endif()

# server
set(server_SRCS
  controllers/database-controller.h
  controllers/database-controller.cpp
  controllers/network-controller.h
  controllers/network-controller.cpp
  )

# Add files that do no need to pass through the moc processor
set(server_SRCS
  ${server_SRCS}
  main.cpp
)

# Resources
set(GCOMPRIS_TEACHERS_RESOURCES "${PROJECT_SOURCE_DIR}/installer")
if(CMAKE_HOST_WIN32)
  set(gcompris_teachers_icon GCompris-teachers.ico)
  set(gcompris_teachers_RES
    ${GCOMPRIS_TEACHERS_RESOURCES}/${gcompris_teachers_icon}
    GCompris-teachers.rc
  )
endif()

include_directories(
  ../core/  # messages
  "${CMAKE_CURRENT_BINARY_DIR}/../core"   # to find config.h
  controllers/
)

# Still use QtCharts instead of QtGraphs because StackedBarSeries is not yet implemented in QtGraphs
find_package(${QT_MAJOR} ${QT_REQUIRED_VERSION} COMPONENTS Charts Widgets)
set_package_properties(${QT_MAJOR}Charts PROPERTIES TYPE REQUIRED)
set_package_properties(${QT_MAJOR}Widgets PROPERTIES TYPE REQUIRED)

set(used_qt_modules ${QT_MAJOR}::Qml ${QT_MAJOR}::Quick ${QT_MAJOR}::Gui ${QT_MAJOR}::Core ${QT_MAJOR}::Svg ${QT_MAJOR}::QuickControls2 ${QT_MAJOR}::Charts ${QT_MAJOR}::Sql)

if(ANDROID)
  add_library(${GCOMPRIS_TEACHERS_EXECUTABLE_NAME} SHARED ${server_SRCS} ${server_MOC})
  set(used_qt_modules ${used_qt_modules} ${QT_MAJOR}::AndroidExtras)
elseif(CMAKE_HOST_APPLE)
  add_executable(${GCOMPRIS_TEACHERS_EXECUTABLE_NAME} MACOSX_BUNDLE ${server_SRCS} ${server_MOC} ${gcompris_RES})
elseif(CMAKE_HOST_WIN32)
  add_executable(${GCOMPRIS_TEACHERS_EXECUTABLE_NAME} WIN32 ${server_SRCS} ${server_MOC} ${gcompris_teachers_RES})
else()
  add_executable(${GCOMPRIS_TEACHERS_EXECUTABLE_NAME} ${server_SRCS} ${server_MOC} ${gcompris_RES})
endif()

target_link_libraries(${GCOMPRIS_TEACHERS_EXECUTABLE_NAME} ${used_qt_modules})
target_link_libraries(${GCOMPRIS_TEACHERS_EXECUTABLE_NAME} OpenSSL::Crypto OpenSSL::SSL)
target_link_libraries(${GCOMPRIS_TEACHERS_EXECUTABLE_NAME} gcompris_core)

gcompris_add_rcc(server
  QML_FILES
  Main.qml
  views/*.qml
  views/*/*.qml
  activities/*.qml
  activities/*/*.qml
  components/*.qml
  dialogs/*.qml
  panels/*.qml
  singletons/*.qml
  *.js
  RESOURCES
  resource/*
  singletons/qmldir
  database/*.sql
  help/*.html
)

if(PACKAGE_SERVER)
  include(PackageServer.cmake)
endif()

=== tests/core/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2018 Himanshu Vishwakarma <himvish997@gmail.com>
#
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
find_package(${QT_MAJOR} REQUIRED COMPONENTS Test)

include_directories(${CMAKE_SOURCE_DIR} "${CMAKE_BINARY_DIR}/src/core/")

set(CORE_TEST_LIBRARIES
    gcompris_core
    ${QT_MAJOR}::Core
    ${QT_MAJOR}::Test
)

ecm_add_tests(ActivityInfoTest.cpp
              ApplicationSettingsTest.cpp
              DatasetTest.cpp
              DirectoryTest.cpp
              FileTest.cpp
              ApplicationInfoTest.cpp
              DownloadManagerTest.cpp
              GImageGrabberTest.cpp
              # add new test file here
              NAME_PREFIX Core
              LINK_LIBRARIES ${CORE_TEST_LIBRARIES})

=== src/activities/baby_tangram/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2019 Johnny Jazeix <jazeix@gmail.com>
#
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
GCOMPRIS_ADD_RESOURCE(activities/baby_tangram
  QML_FILES
  *.qml
  dataset.js
  RESOURCES
  *.svg
  resource/*/*.svg
  DEPENDENCIES
  tangram
)

=== src/activities/bargame_2players/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2017 UTKARSH TIWARI <iamutkarshtiwari@kde.org>
#
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
GCOMPRIS_ADD_RESOURCE(activities/bargame_2players
  QML_FILES
  *.qml
  RESOURCES
  *.svg
  DEPENDENCIES
  bargame
)

=== src/activities/binary_bulb/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2018 Rajat Asthana <rajatasthana4@gmail.com>
#
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
GCOMPRIS_ADD_RESOURCE(activities/binary_bulb
  QML_FILES
  *.qml
  *.js
  resource/*.qml
  resource/*/Data.qml
  RESOURCES
  *.svg
  resource/*.svg
)

=== src/activities/drawing_wheels/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2025 Bruno Anselme <be.root@free.fr>
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
GCOMPRIS_ADD_RESOURCE(activities/drawing_wheels
  QML_FILES
  *.qml
  *.js
  RESOURCES
  *.svg
  resource/*
)

=== debian/changelog ===
gcompris-qt (26.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.7.3, no changes required.
  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.
  * Drop Priority: optional, no more needed since dpkg 1.22.13.
  * Update the patches:
    - disable-openssl.diff: drop, now OpenSSL is actually used
  * Update the build dependencies according to the upstream build system:
    - add libssl-dev, qt6-graphs-dev, and qt6-quick3d-dev
  * Update install files.

 -- Pino Toscano <pino@debian.org>  Wed, 04 Feb 2026 08:07:17 +0100

=== debian/control ===
Source: gcompris-qt
Section: education
Maintainer: Debian Qt Extras Team <debian-qt-kde@lists.debian.org>
Uploaders: Simon Quigley <tsimonq2@debian.org>
Build-Depends: cmake (>= 3.16~),
               debhelper-compat (= 13),
               extra-cmake-modules,
               libkf6doctools-dev,
               libssl-dev,
               pkg-kde-tools,
               qt6-base-dev (>= 6.5.0~),
               qt6-base-private-dev (>= 6.5.0~),
               qt6-charts-dev (>= 6.5.0~),
               qt6-declarative-dev (>= 6.5.0~),
               qt6-declarative-private-dev (>= 6.5.0~),
               qt6-graphs-dev (>= 6.5.0~),
               qt6-multimedia-dev (>= 6.5.0~),
               qt6-quick3d-dev (>= 6.5.0~),
               qt6-sensors-dev (>= 6.5.0~),
               qt6-svg-dev (>= 6.5.0~),
               qt6-tools-dev (>= 6.5.0~),
               qt6-wayland-dev (>= 6.5.0~) [linux-any],
               qt6-wayland-private-dev (>= 6.5.0~) [linux-any],
               xauth <!nocheck>,
               xvfb <!nocheck>,
Standards-Version: 4.7.3
Homepage: https://gcompris.net/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/gcompris-qt
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/gcompris-qt.git

Package: gcompris-qt
Architecture: any
Depends: gcompris-qt-data (= ${source:Version}),
         qml6-module-qtcharts,
         qml6-module-qtmultimedia,
         qml6-module-qtquick,
         qml6-module-qtquick-controls,
         qml6-module-qtquick-effects,
         qml6-module-qtquick-layouts,
         qml6-module-qtquick-particles,
         qml6-module-qtquick-shapes,
         qml6-module-qtquick-window,
         qml6-module-qtsensors,
         qt6-image-formats-plugins,
         qt6-svg-plugins,
         ${misc:Depends},
         ${shlibs:Depends}
Description: educational games for small children
 GCompris is a high quality educational software suite, including a large
 number of activities for children aged 2 to 10. Some of the activities
 are game orientated, but nonetheless still educational.

Package: gcompris-qt-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: gcompris-qt
Description: data files for gcompris-qt
 GCompris is a high quality educational software suite, including a large
 number of activities for children aged 2 to 10. Some of the activities
 are game orientated, but nonetheless still educational.
 .
 This package contains the data file for gcompris-qt.
